<?php
/*
 This program is distributed under the terms of the GNU General Public License.
 See the README & COPYING files for more information.
 Copyright (C) 2004  Kevin L. Papendick <kevinp@polarlava.com>
*/

	//--- Includes
	require('config/config.php');
	require_once(LIB_PATH . 'Localization_class.php');

	$date = (defined('I18N_DATE_FORMAT')) ? strftime(I18N_DATE_FORMAT) :	date(DATE_FORMAT);
	$langObj = new Localization(I18N_LANG, './lang/');
	$close = $langObj->get('CLOSE');
	$entry_preview = $langObj->get('ENTRY_PREVIEW');
	$posted_by = $langObj->get('POSTED_BY');

	if (defined('DOCTYPE') && DOCTYPE == 'HTML Strict') {
		$doctype = <<<HSTRICT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>

HSTRICT;
	} elseif (defined('DOCTYPE') && DOCTYPE == 'HTML Transitional') {
		$doctype = <<<HTRANS
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>

HTRANS;
	} elseif (defined('DOCTYPE') && DOCTYPE == 'XHTML Transitional') {
		$doctype = <<<XTRANS
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

XTRANS;
	} else {
		$doctype = <<<XSTRICT
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

XSTRICT;
	}

echo $doctype;
?>
	<head>
		<title><?php echo PAGE_TITLE . ' - ' . $entry_preview; ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<meta name="Author" content="Kevin L. Papendick" />
		<meta name="Copyright" content="Kevin L. Papendick" />
		<meta name="description" content="PolarBlog - An Embedded Weblog Solution" />
		<style type="text/css" media="all">@import "css/<?php echo CSS; ?>";</style>
		<script type="text/javascript" src="<?php echo JS_URL; ?>general.js" defer="defer"></script>
	</head>
	<body onload="populate_preview();">
<div class="pb_entry">
		<div class="pb_topic_icon">
			<span class="pb_title"><div id="title_div"></div></span>
	 		<span class="pb_created"><?php echo $date; ?></span>
	 		<br />
	 		<span class="pb_created"><?php echo $posted_by . ' PolarBlog'; ?></span>
		</div>
		<div class="pb_body">
			<div id="body_div"></div>
			<br />
			<div id="more_div"></div>
		</div>
		<br />
		<div align="center"><input type="button" name="close" value="<?php echo $close; ?>" onclick="window.close();" /></div>
</div>
	</body>
</html>
