<?php
/*
 This program is distributed under the terms of the GNU General Public License.
 See the README & COPYING files for more information.
 Copyright (C) 2004-2007  Kevin L. Papendick <kevinp@polarlava.com>
*/


	//--- PolarBlog Session
	require_once('./config/config.php');
	//--- Require cookie use if > V4.3.0
	if (version_compare(phpversion(), '4.3.0', '>')) {
		ini_set('session.use_only_cookies', '1');
	}
	ini_set('session.cookie_httponly', '1');
	if (defined('PB_SESSION_PATH')) {
		session_save_path(PB_SESSION_PATH);
	}
	session_name(PB_SESSION_NAME);
	if (isset($_COOKIE[PB_SESSION_NAME]) && !preg_match('/[\w]{32}/', $_COOKIE[PB_SESSION_NAME])) {
		setcookie(PB_SESSION_NAME, '', -1);
	}
	session_start();
	header('Cache-control: private'); //IE6 Form Fix - http://www.phpfreaks.com/tutorials/41/1.php

	//--- Remember Commentor
	if ((isset($_POST['edit_mode']) && $_POST['edit_mode'] == 'comment_insert') && (isset($_POST['remember_me']) && $_POST['remember_me'] == 1)) {
		$clean['name'] = (isset($_POST['name']) && ctype_print($_POST['name'])) ? trim(strip_tags($_POST['name'])) : '';
		$pattern = '/^((?:(?:(?:[a-zA-Z0-9][\.\-\+_]?)*)[a-zA-Z0-9])+)\@((?:(?:(?:[a-zA-Z0-9][\.\-_]?){0,62})[a-zA-Z0-9])+)\.([a-zA-Z0-9]{2,6})$/';
		$clean['email'] = (isset($_POST['email']) && preg_match($pattern, $_POST['email'])) ? trim($_POST['email']) : '';
		$clean['url'] = (isset($_POST['url']) && preg_match('/^[\w:\/.-]+$/', $_POST['url'])) ? strip_tags($_POST['url']) : '';
		$clean['url'] = str_replace('http://', '', $clean['url']);
		$clean['url'] = str_replace('https://', '', $clean['url']);
		$expire = mktime(0, 0, 0, 1, 1, 2030);
		setcookie('pb_comment[name]', $clean['name'], $expire, '/');
		setcookie('pb_comment[email]', $clean['email'], $expire, '/');
		setcookie('pb_comment[url]', $clean['url'], $expire, '/');
	}
	//--- Unremember Commentor
	if ((isset($_POST['edit_mode']) && $_POST['edit_mode'] == 'comment_insert') && !isset($_POST['remember_me'])) {
		$expire = time() - 3600;
		setcookie('pb_comment[name]', '', $expire);
		setcookie('pb_comment[email]', '', $expire);
		setcookie('pb_comment[url]', '', $expire);
		unset($_COOKIE['pb_comment']);
	}
?>
