<?php
/*
 This program is distributed under the terms of the GNU General Public License.
 See the README & COPYING files for more information.
 Copyright (C) 2004-2009  Kevin L. Papendick <kevinp@polarlava.com>
*/


	//--- Config
	require('./config/config.php');
	setlocale(LC_TIME, I18N_LANG);

	//--- Page Timer
	if (defined('USE_TIMER') && USE_TIMER) {
		require(LIB_PATH . 'Timer.php');
		$page_timer = new Timer();
	}

	//--- Output Compression
	if (defined('USE_GZ_OUTPUT') && USE_GZ_OUTPUT) {
		ob_start();
		require(LIB_PATH . 'GzContent.php');
	}

	require('./header.php');

	if (defined('DOCTYPE') && DOCTYPE == 'HTML Strict') {
		$doctype = <<<HSTRICT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>

HSTRICT;
	} elseif (defined('DOCTYPE') && DOCTYPE == 'HTML Transitional') {
		$doctype = <<<HTRANS
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>

HTRANS;
	} elseif (defined('DOCTYPE') && DOCTYPE == 'XHTML Transitional') {
		$doctype = <<<XTRANS
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

XTRANS;
	} else {
		$doctype = <<<XSTRICT
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

XSTRICT;
	}

echo $doctype;
?>
	<head>
		<title><?php echo PAGE_TITLE ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=<?php echo I18N_CHARSET; ?>" />
		<meta name="Author" content="Kevin L. Papendick" />
		<meta name="Copyright" content="Kevin L. Papendick" />
		<meta name="description" content="PolarBlog - An Embedded Weblog Solution" />
		<style type="text/css" media="all">@import "css/<?php echo CSS; ?>";</style>
		<link rel="alternate" title="<?php echo BLOG_NAME; ?> RSS" href="<?php echo BASE_URL ?>rss.php" type="application/rss+xml" />
		<script type="text/javascript" src="<?php echo JS_URL; ?>general.js" defer="defer"></script>
<?php
	//--- Speller Pages
	if (defined('USE_SPELLER') && USE_SPELLER) {
?>
		<script type="text/javascript" src="<?php echo SPELLER_PATH; ?>spellChecker.js" defer="defer"></script>
		<script type="text/javascript" src="<?php echo JS_URL; ?>speller.js" defer="defer"></script>
<?php
	}

	//--- Comments
	if (defined('USE_COMMENTS') && USE_COMMENTS) {
?>
		<script type="text/javascript" src="<?php echo JS_URL; ?>comments.js" defer="defer"></script>
<?php
	}
?>
	</head>
	<body>
<?php
	include('polarblog.php');
	if (defined('USE_TIMER') && USE_TIMER) {
		$ptime = $page_timer->getPageTime();
		echo '<!-- Page Time: ' . $ptime . " -->\n";
	}
?>
	</body>
</html>
<?php
	if (defined('USE_GZ_OUTPUT') && USE_GZ_OUTPUT) {
		new GzContent(GZ_LEVEL, GZ_DEBUG);
	}
?>
