<?php
/*
 This program is distributed under the terms of the GNU General Public License.
 See the README & COPYING files for more information.
 Copyright (C) 2004-2006  Kevin L. Papendick <kevinp@polarlava.com>
*/

	//--- Includes
	require('./config/config.php');
	require(LIB_PATH . 'MySqlDb_class.php');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title>PolarBlog Installation &amp; Updgrade Utility</title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
		<meta name="Author" content="Kevin L. Papendick" />
		<meta name="Copyright" content="Kevin L. Papendick" />
		<meta name="description" content="PolarBlog - An Embedded Weblog Solution" />
		<style>
				body {
					margin:10px;
					padding:0px;
					font-family:verdana, arial, helvetica, sans-serif;
					color:black;
					background-color:#f2efb7;
					}
				th {
					text-align: left;
				}
		</style>
		<script type="text/javascript" defer="defer">
		<!--
			function verify(myForm) {
				if (myForm.db_passwd.value.length == 0 || myForm.db_passwd.value != myForm.db_passwd2.value) {
					alert('Database password verfication failed, please check your password and try again.');
					return false;
				}

				var mode;
				mode=getCheckedValue(myForm.install)
				if (mode == 0 || mode == 1) {
					if (myForm.user.value.length == 0) {
						alert('Administrator Username cannot be blank, please try again.');
						return false;
					}
					if (myForm.passwd.value.length == 0 || myForm.passwd.value != myForm.passwd2.value) {
						alert('Administrator Password verfication failed, please check your password and try again.');
						return false;
					}
					if (myForm.post_by.value.length == 0) {
						alert('Admin Post As cannot be blank, please try again.');
						return false;
					}
				}
			}

			function unhide(targetId)
			{
				document.getElementById;
				target = document.getElementById(targetId);
				target.style.display = 'block';
			}
			function hide(targetId)
			{
				document.getElementById;
				target = document.getElementById(targetId);
				target.style.display = 'none';
			}

			function toggle(targetId) {
				if (document.getElementById) {
					target = document.getElementById( targetId );
					if (target.style.display == 'none') {
						target.style.display = 'block';
					} else {
						target.style.display = 'none';
					}
				}
			}

			function getCheckedValue(radioObj) {
				if(!radioObj)
					return "";
				var radioLength = radioObj.length;
				if(radioLength == undefined)
					if(radioObj.checked)
						return radioObj.value;
					else
						return "";
				for(var i = 0; i < radioLength; i++) {
					if(radioObj[i].checked) {
						return radioObj[i].value;
					}
				}
				return "";
			}

		-->
		</script>
	</head>
	<body>
	<h1>PolarBlog Installation &amp; Upgrade Utility</h1>
<?php
	$error = FALSE;
	if (isset($_POST['submit'])) {
		$dbObj = new MySqlDb($_POST['db_host'], $_POST['db_name'], $_POST['db_user'], $_POST['db_passwd'], 'standard', $_POST['db_port']);
		$error = $dbObj->getError();
		$dbObj->setDebug(TRUE);
	}

	if ($error) {
		echo '<p>Unable to create a database object, please check your database settings in lib/PbDb_class.php</p>';
		echo '<p><strong>DB Error:</strong> ' . $error . "</p>\n";
	} elseif (isset($_POST['submit'])) {
		$msg = array();
		if (isset($_POST['install']) && $_POST['install'] == 0) {
			//--- New Installation;
			$stat = install($dbObj, $_POST['db_prefix'], $_POST['user'], $_POST['passwd'], $_POST['hint'], $_POST['post_by'], $_POST['email']);
			$msg[0] = 'New PolarBlog Installation';
		} elseif (isset($_POST['install']) && $_POST['install'] == 1) {
			$stat = migrate($dbObj, $_POST['db_prefix'], $_POST['user'], $_POST['passwd'], $_POST['hint'], $_POST['post_by'], $_POST['email']);
			$msg[0] = 'Personal Weblog Migration';
		} elseif (isset($_POST['install']) && $_POST['install'] == 2) {
			$stat = cleanup($dbObj, $_POST['db_prefix']);
			$msg[0] = 'Personal Weblog Cleanup';
		} elseif (isset($_POST['install']) && $_POST['install'] == 3) {
			$stat = upgrade($dbObj, $_POST['db_prefix']);
			$msg[0] = 'PolarBlog Commenting Upgrade';
			$msg[1] = 'PolarBlog Comment Fix';
			$msg[2] = 'PolarBlog Comment IP Logging';
			$msg[3] = 'PolarBlog Email Posting';
			$msg[4] = 'PolarBlog Alternate Email Posting';
			$msg[5] = 'PolarBlog Improved Entry Indexing';
			$msg[6] = 'PolarBlog FULTEXT Search Check';
			$msg[7] = 'PolarBlog RBL Blocking';
			$msg[8] = 'PolarBlog RBL Keywords';
			for ($i = 9; $i <= 19; $i++) {
				$msg[$i] = 'PolarBlog RBL Keyword ' . $i;
			}
		} else {
			echo '<p>Error: Unknown installation mode.&nbsp;&nbsp;Code:' . $_POST['install'] . "</p>\n";
		}


		//--- Status Report
		echo '<hr />';
		$error = FALSE;
		$cnt = 0;
		foreach ($stat as $status) {
			if (!$status) {
				echo "<p><strong>Error:</strong> Your $msg[$cnt] did not complete succesfully!</p>\n";
				$error = TRUE;
			}
			++$cnt;
		}

		echo '<hr />';
		if ($error) {
			echo '<p><strong>Installation/Upgrade Failure:</strong> Unfortunately it appears that your PolarBlog installation or upgrade has failed.&nbsp;&nbsp;There should be query error message(s) listed above that should help you diagnose the problem.&nbsp;&nbsp;For further assistance, please join and send a message to the <a href="http://polarblog.polarlava.com/list/" title="PolarBlog Mailing List">PolarBlog Mailing List</a>.</p>';
			echo "<p><strong>WARNING!!!</strong>&nbsp;&nbsp;If you are not going to fix this problem at this time, you should immediately delete the &quot;install.php&quot; file to prevent potential tampering with your system!</p>\n";
		} else {
			echo '<p><strong>Installation/Upgrade Succeded:</strong> Congratulations, your PolarBlog installation or upgrade has succeded!&nbsp;&nbsp;Click <a href="' . BASE_URL . '" title="Your PolarBlog Installation">here</a> to proceed to your new blog.</p>';
			echo "<p><strong>WARNING!!!</strong>&nbsp;&nbsp;You should immediately delete the &quot;install.php&quot; file to prevent potential tampering with your system!</p>\n";
		}
	} else {
?>
		<form method="post" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" onsubmit="return verify(this);">
		<table>
			<tr>
				<th colspan="2">Installation &amp; Migration</th>
			</tr>
			<tr>
				<th colspan="2">&nbsp;&nbsp;<input type="radio" name="install" id="install" value="0" checked="checked" onclick="unhide('admin_div');" /><label for="install">New PolarBlog Installation</label></th>
			</tr>
			<tr>
				<th colspan="2">&nbsp;&nbsp;<input type="radio" name="install" id="migrate" value="1" onclick="unhide('admin_div');" /><label for="migrate">Migrate from Personal Weblog (PWL)</label></th>
			</tr>
			<tr>
				<th colspan="2">&nbsp;&nbsp;<input type="radio" name="install" id="cleanup" value="2" onclick="hide('admin_div')" /><label for="cleanup">Personal Weblog (PWL) Migration Cleanup</label></th>
			</tr>
			<tr>
				<th colspan="2">&nbsp;</th>
			</tr>
			<tr>
				<th colspan="2">Upgrades</th>
			</tr>
			<tr>
				<th colspan="2">&nbsp;&nbsp;<input type="radio" name="install" id="upgrade" value="3" onclick="hide('admin_div');" /><label for="upgrade">Upgrade PolarBlog</label></th>
			</tr>
			<tr>
				<td colspan="2"><hr /></td>
			</tr>
			<tr>
				<td colspan="2">You should setup your config file before running this utility!</td>
			</tr>
			<tr>
				<th>Database Table Prefix:</th>
				<td><input type="text" name="db_prefix" size="10" maxlength="10" value="<?php echo DB_PREFIX; ?>" /></td>
			</tr>
			<tr>
				<th>Database Host:</th>
				<td><input type="text" name="db_host" size="30" maxlength="32" value="<?php echo DB_HOST; ?>" /></td>
			</tr>
			<tr>
				<th>Database Name:</th>
				<td><input type="text" name="db_name" size="30" maxlength="32" value="<?php echo DB_NAME; ?>" /></td>
			</tr>
			<tr>
				<th>Database Port:</th>
				<td><input type="text" name="db_port" size="4" maxlength="5" value="<?php echo DB_PORT; ?>" /></td>
			</tr>
			<tr>
				<th>Database Username:</th>
				<td><input type="text" name="db_user" size="30" maxlength="32" value="<?php echo DB_USER; ?>" /></td>
			</tr>
			<tr>
				<th>Database Password:</th>
				<td><input type="password" name="db_passwd" size="30" maxlength="32" value="" /></td>
			</tr>
			<tr>
				<th>Database Password Verify:</th>
				<td><input type="password" name="db_passwd2" size="30" maxlength="32" value="" /></td>
			</tr>
		</table>
		<div id="admin_div" style="display: block;">
		<table>
			<tr>
				<td colspan="2">The following are required for new installations and PWL migrations.</td>
			</tr>
			<tr>
				<th>Admin Username:</th>
				<td><input type="text" name="user" size="30" maxlength="32" value="" /></td>
			</tr>
			<tr>
				<th>Admin Password:</th>
				<td><input type="password" name="passwd" size="30" maxlength="32" value="" /></td>
			</tr>
			<tr>
				<th>Admin Password Verify:</th>
				<td><input type="password" name="passwd2" size="30" maxlength="32" value="" /></td>
			</tr>
			<tr>
				<th>Password Hint:</th>
				<td><input type="text" name="hint" size="50" maxlength="100" value="" /></td>
			</tr>
			<tr>
				<th>Admin Post As:</th>
				<td><input type="text" name="post_by" size="50" maxlength="50" value="" /></td>
			</tr>
			<tr>
				<th>Admin Email:</th>
				<td><input type="text" name="email" size="50" maxlength="100" value="" /></td>
			</tr>
		</table>
		</div>
		<table>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td><input type="submit" name="submit" value="Submit" /> <input type="reset" name="reset" value="Reset" /></td>
			</tr>
		</table>
		</form>
<?php
	}
?>
	</body>
</html>
<?php

//------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------
	//--- New Installation
	function install(&$dbObj, $db_prefix, $user, $passwd, $hint, $post_by, $email) {

		$stat = array(TRUE);
		$sql = array();
		$sql[0] = <<< TOPICS
			CREATE TABLE IF NOT EXISTS `{$db_prefix}topics` (
			  `tid` int(11) NOT NULL auto_increment,
			  `name` varchar(80) NOT NULL default '',
			  `icon` varchar(128) NOT NULL default '',
			  PRIMARY KEY  (`tid`),
			  KEY `name_idx` (`name`)
			) TYPE=MyISAM;
TOPICS;

		$sql[22] = "INSERT INTO `{$db_prefix}topics` (name, icon) VALUES ('News','gfx/announcement.png');";

		$sql[1] = <<< ENTRIES
			CREATE TABLE IF NOT EXISTS `{$db_prefix}entries` (
			  `eid` int(11) NOT NULL auto_increment,
			  `title` varchar(200) NOT NULL default '',
			  `tid` int(11) NOT NULL default '0',
			  `created` int(11) NOT NULL default '0',
			  `updated` int(11) NOT NULL default '0',
			  `post_by` varchar(50) NOT NULL default '',
			  `uid` tinyint(3) unsigned NOT NULL default '0',
			  `display` enum('0','1') NOT NULL default '1',
			  `comments` enum('0','1') NOT NULL default '1',
			  `body` text NOT NULL,
			  `more` text NOT NULL,
			  `tb_url` varchar(100) NOT NULL default '',
			  PRIMARY KEY  (`eid`),
			  KEY `updt_disp_idx` (`updated`, `display`),
			  KEY `disp_updt_idx` (`display`, `updated`),
			  FULLTEXT KEY `title` (`title`,`body`,`more`)
			) TYPE=MyISAM;
ENTRIES;

		$sql[2] = <<< USERS
			CREATE TABLE IF NOT EXISTS `{$db_prefix}users` (
				id tinyint(3) unsigned NOT NULL auto_increment,
				user char(32) NOT NULL default '',
				password char(32) NOT NULL default '',
				email char(100) NOT NULL default '',
				hint char(100) NOT NULL default '',
				post_by char(50) NOT NULL default '',
				post_entry enum('0','1') NOT NULL default '0',
				post_comment enum('0','1') NOT NULL default '1',
				admin enum('0','1') NOT NULL default '0',
				timestamp timestamp(14) NOT NULL,
				pop3 enum('0','1') NOT NULL default '1',
				pop3_alt_email char(255) NOT NULL default '',
			  PRIMARY KEY (`id`),
			  UNIQUE KEY `user_idx` (`user`)
			) TYPE=MyISAM;
USERS;

		$sql[3] = <<< COMMENTS
			CREATE TABLE IF NOT EXISTS `{$db_prefix}comments` (
			  `cid` int(10) unsigned NOT NULL auto_increment,
			  `eid` int(10) unsigned NOT NULL default '0',
			  `pid` int(10) unsigned NOT NULL default '0',
			  `name` varchar(50) NOT NULL default '',
			  `email` varchar(100) NOT NULL default '',
			  `url` varchar(100) NOT NULL default '',
			  `display` enum('0','1') NOT NULL default '1',
			  `comment` text NOT NULL,
			  `trackback` ENUM('0','1') NOT NULL DEFAULT '0',
			  `timestamp` timestamp(14) NOT NULL,
			  `ip` char(15) NOT NULL DEFAULT '000.000.000.000',
			  PRIMARY KEY  (`cid`),
			  KEY `ord_idx` (`eid`,`pid`,`display`,`timestamp`)
			) TYPE=MyISAM;
COMMENTS;

		$sql[4] = <<< ADMIN
			INSERT INTO
				`{$db_prefix}users`
				(
					user,
					password,
					email,
					hint,
					post_by,
					post_entry,
					post_comment,
					admin,
					timestamp
				)
			VALUES
				(
					'$user',
					MD5(MD5('$passwd')),
					'$email',
					'$hint',
					'$post_by',
					'1',
					'1',
					'1',
					NOW()
				);
ADMIN;

		//--- RBL
		$sql[5] = <<< RBL_BLOCKED
				CREATE TABLE IF NOT EXISTS `{$db_prefix}rbl_blocked` (
				  `id` int(8) NOT NULL auto_increment,
				  `ip` char(15) NOT NULL default '',
				  `visits` int(8) NOT NULL default '0',
				  `lastseen` datetime NOT NULL,
				  `services` char(255) NOT NULL default '',
				  `referer` char(255) default NULL,
				  `whitelist` enum('0','1') NOT NULL default '0',
				  PRIMARY KEY (`id`),
				  UNIQUE KEY `ip_idx` (`ip`)
				) TYPE=MyISAM;
RBL_BLOCKED;

		$sql[6] = <<< RBL_KEYWORDS
				CREATE TABLE IF NOT EXISTS `{$db_prefix}rbl_keywords` (
				  `id` int(8) NOT NULL auto_increment,
				  `keyword` char(20) NOT NULL default '',
				  `occurances` int(8) NOT NULL default '0',
				  `lastseen` datetime NOT NULL,
				  PRIMARY KEY (`id`),
				  UNIQUE KEY `keyword_idx` (`keyword`)
				) TYPE=MyISAM;
RBL_KEYWORDS;

		//--- RBL Keywords
		$sql[7] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('viagra', 0, NOW());";
		$sql[8] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('phentermine', 0, NOW());";
		$sql[9] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('cialis', 0, NOW());";
		$sql[10] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('adipex', 0, NOW());";
		$sql[11] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('hydrocodone', 0, NOW());";
		$sql[12] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('xanax', 0, NOW());";
		$sql[13] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('vicodin', 0, NOW());";
		$sql[14] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('fioricet', 0, NOW());";
		$sql[15] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('valium', 0, NOW());";
		$sql[16] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('poker', 0, NOW());";
		$sql[17] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('holdem', 0, NOW());";
		$sql[18] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('albuterol', 0, NOW());";
		$sql[19] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('lorazepam', 0, NOW());";
		$sql[20] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('ringtone', 0, NOW());";
		$sql[21] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('mp3city', 0, NOW());";
		// index 22 used above!

		foreach ($sql as $query) {
			if (!$dbObj->query($query)) {
				$stat[0] = FALSE;
				echo '<p><strong>DB Error:</strong> ' . $dbObj->getError() . "</p>\n";
			}
		}

		return $stat;
	}


//------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------
	//--- PWL Migration
	function migrate(&$dbObj, $db_prefix, $user, $passwd, $hint, $post_by, $email) {

		$stat = array(TRUE);
		$sql = array();
		$sql[0] = <<< ENTRY_DISPLAY
			ALTER TABLE {$db_prefix}entries ADD COLUMN display ENUM('0','1') DEFAULT '1' NOT NULL AFTER updated;
ENTRY_DISPLAY;

		$sql[1] = <<< ENTRY_INDEX
			CREATE INDEX updt_disp_idx ON {$db_prefix}entries (updated, display);
ENTRY_INDEX;

		$sql[2] = <<< ENTRY_COMMENT
			ALTER TABLE {$db_prefix}entries ADD COLUMN comments ENUM('0','1') DEFAULT '1' NOT NULL AFTER display;
ENTRY_COMMENT;

		$sql[3] = <<< ENTRY_POST_BY
			ALTER TABLE {$db_prefix}entries ADD COLUMN post_by CHAR(50) NOT NULL AFTER updated;
ENTRY_POST_BY;

		$sql[4] = <<< ENTRY_UID
			ALTER TABLE {$db_prefix}entries ADD COLUMN uid TINYINT UNSIGNED NOT NULL AFTER post_by;
ENTRY_UID;

		$sql[5] = <<< ENTRY_TB
			ALTER TABLE {$db_prefix}entries ADD COLUMN tb_url varchar(100) NOT NULL DEFAULT '' AFTER more;
ENTRY_TB;

		$sql[6] = <<< ENTRY_SEARCH
			ALTER TABLE {$db_prefix}entries ADD FULLTEXT(title,body,more);
ENTRY_SEARCH;

		$sql[7] = <<< ENTRY_POST_AS
			UPDATE {$db_prefix}entries SET post_by='{$post_by}';
ENTRY_POST_AS;

		$sql[8] = <<< ENTRY_SET_UID
			UPDATE {$db_prefix}entries SET uid='1';
ENTRY_SET_UID;

		$sql[9] = <<< USERS_M
			CREATE TABLE IF NOT EXISTS `{$db_prefix}users` (
				id tnyint(3) unsigned NOT NULL auto_increment,
				user char(32) NOT NULL default '',
				password char(32) NOT NULL default '',
				email char(100) NOT NULL default '',
				hint char(100) NOT NULL default '',
				post_by char(50) NOT NULL default '',
				post_entry enum('0','1') NOT NULL default '0',
				post_comment enum('0','1') NOT NULL default '1',
				admin enum('0','1') NOT NULL default '0',
				timestamp timestamp(14) NOT NULL,
				pop3 enum('0','1') NOT NULL default '1',
			  PRIMARY KEY (`id`),
			  UNIQUE KEY `user_idx` (`user`)
			) TYPE=MyISAM;
USERS_M;

		$sql[10] = <<< COMMENTS_M
			CREATE TABLE IF NOT EXISTS `{$db_prefix}comments` (
			  `cid` int(10) unsigned NOT NULL auto_increment,
			  `eid` int(10) unsigned NOT NULL default '0',
			  `pid` int(10) unsigned NOT NULL default '0',
			  `name` varchar(50) NOT NULL default '',
			  `email` varchar(100) NOT NULL default '',
			  `url` varchar(100) NOT NULL default '',
			  `display` enum('0','1') NOT NULL default '1',
			  `comment` text NOT NULL,
			  `trackback` ENUM('0','1') NOT NULL DEFAULT '0',
			  `timestamp` timestamp(14) NOT NULL,
			  `ip` char(15) NOT NULL DEFAULT '000.000.000.000',
			  PRIMARY KEY  (`cid`),
			  KEY `ord_idx` (`eid`,`pid`,`display`,`timestamp`)
			) TYPE=MyISAM;
COMMENTS_M;

		$sql[11] = <<< ADMIN_M
			INSERT INTO
				`{$db_prefix}users`
				(
					user,
					password,
					email,
					hint,
					post_by,
					post_entry,
					post_comment,
					admin,
					timestamp
				)
			VALUES
				(
					'$user',
					MD5(MD5('$passwd')),
					'$email',
					'$hint',
					'$post_by',
					'1',
					'1',
					'1',
					NOW()
				);
ADMIN_M;

		//--- RBL
		$sql[12] = <<< RBL_BLOCKED
				CREATE TABLE IF NOT EXISTS `{$db_prefix}rbl_blocked` (
				  `id` int(8) NOT NULL auto_increment,
				  `ip` char(15) NOT NULL default '',
				  `visits` int(8) NOT NULL default '0',
				  `lastseen` datetime NOT NULL,
				  `services` char(255) NOT NULL default '',
				  `referer` char(255) default NULL,
				  `whitelist` enum('0','1') NOT NULL default '0',
				  PRIMARY KEY (`id`),
				  UNIQUE KEY `ip_idx` (`ip`)
				) TYPE=MyISAM;
RBL_BLOCKED;

		$sql[13] = <<< RBL_KEYWORDS
				CREATE TABLE IF NOT EXISTS `{$db_prefix}rbl_keywords` (
				  `id` int(8) NOT NULL auto_increment,
				  `keyword` char(20) NOT NULL default '',
				  `occurances` int(8) NOT NULL default '0',
				  `lastseen` datetime NOT NULL,
				  PRIMARY KEY (`id`),
				  UNIQUE KEY `keyword_idx` (`keyword`)
				) TYPE=MyISAM;
RBL_KEYWORDS;

		//--- RBL Keywords
		$sql[14] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('viagra', 0, NOW());";
		$sql[15] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('phentermine', 0, NOW());";
		$sql[16] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('cialis', 0, NOW());";
		$sql[17] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('adipex', 0, NOW());";
		$sql[18] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('hydrocodone', 0, NOW());";
		$sql[19] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('xanax', 0, NOW());";
		$sql[20] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('vicodin', 0, NOW());";
		$sql[21] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('fioricet', 0, NOW());";
		$sql[22] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('valium', 0, NOW());";
		$sql[23] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('poker', 0, NOW());";
		$sql[24] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('holdem', 0, NOW());";
		$sql[25] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('albuterol', 0, NOW());";
		$sql[26] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('lorazepam', 0, NOW());";
		$sql[27] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('ringtone', 0, NOW());";
		$sql[28] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('mp3city', 0, NOW());";

		$sql[29] = <<< ENTRY_INDEX2
			CREATE INDEX disp_updt_idx ON {$db_prefix}entries (display,updated);
ENTRY_INDEX2;

		$sql[30] = <<< TOPIC_INDEX
			CREATE INDEX name_idx ON {$db_prefix}topics (name);
TOPIC_INDEX;

		foreach ($sql as $query) {
			if (!$dbObj->query($query)) {
				$stat[0] = FALSE;
				echo '<p><strong>DB Error:</strong> ' . $dbObj->getError() . "</p>\n";
			}
		}

		return $stat;
	}


//------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------
	//--- PWL Cleanup
	function cleanup($dbObj, $db_prefix) {

		$stat = array(TRUE);
		$sql = array();
		$sql[0] = <<< DROP_VARS
			DROP TABLE IF EXISTS `{$db_prefix}vars`;
DROP_VARS;

		foreach ($sql as $query) {
			if (!$dbObj->query($query)) {
				$stat[0] = FALSE;
				echo '<p><strong>DB Error:</strong> ' . $dbObj->getError() . "</p>\n";
			}
		}

		return $stat;
	}

//------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------
	//--- Upgrade
	function upgrade(&$dbObj, $db_prefix) {

		$stat = array();
		$sql = array();

		//--- Implement Commenting
		$sql[0]['test'] = "SELECT COUNT(cid) FROM {$db_prefix}comments";
		$sql[0]['execute'] = <<< COMMENTS_U
			CREATE TABLE IF NOT EXISTS `{$db_prefix}comments` (
			  `cid` int(10) unsigned NOT NULL auto_increment,
			  `eid` int(10) unsigned NOT NULL default '0',
			  `pid` int(10) unsigned NOT NULL default '0',
			  `name` varchar(50) NOT NULL default '',
			  `email` varchar(100) NOT NULL default '',
			  `url` varchar(100) NOT NULL default '',
			  `display` enum('0','1') NOT NULL default '1',
			  `comment` text NOT NULL,
			  `timestamp` timestamp(14) NOT NULL,
			  PRIMARY KEY  (`cid`),
			  KEY `ord_idx` (`eid`,`pid`)
			) TYPE=MyISAM;
COMMENTS_U;

		//--- Comment Looping Fix
		$sql[1]['test'] = "SELECT force_execute FROM {$db_prefix}comments";
		$sql[1]['execute'] = <<< COMMENTS_FIX
			UPDATE
				`{$db_prefix}comments`
			SET
				pid='0'
			WHERE
				eid=pid;
COMMENTS_FIX;

		//--- Comment IP Logging
		$sql[2]['test'] = "SELECT COUNT(ip) FROM {$db_prefix}comments";
		$sql[2]['execute'] = <<< COMMENTS_IP
			ALTER TABLE
				`{$db_prefix}comments`
			ADD COLUMN
			  `ip` char(15) NOT NULL default '000.000.000.000'
			AFTER
				timestamp;
COMMENTS_IP;

		//--- Email Posting
		$sql[3]['test'] = "SELECT COUNT(pop3) FROM {$db_prefix}users";
		$sql[3]['execute'] = <<< EMAIL_POST
			ALTER TABLE
				{$db_prefix}users
			ADD COLUMN
				pop3 enum('0','1') NOT NULL default '1'
			AFTER
				timestamp;
EMAIL_POST;
		$sql[4]['test'] = "SELECT COUNT(pop3_alt_email) FROM {$db_prefix}users";
		$sql[4]['execute'] = <<< EMAIL_POST_OTHERS
			ALTER TABLE
				{$db_prefix}users
			ADD COLUMN
				pop3_alt_email char(255) NOT NULL default ''
			AFTER
				pop3;
EMAIL_POST_OTHERS;

		//--- Improved Entry Indexing
		$sql[5]['test'] = "SELECT force_execute FROM {$db_prefix}entries";
		$sql[5]['special_function'] = 'idx_chk';
		$sql[5]['special_chk_query'] = "SHOW INDEX FROM `{$db_prefix}entries`";
		$sql[5]['special_chk_value'] = 'updated_idx';
		$sql[5]['special_action_query'] = "DROP INDEX updated_idx ON `{$db_prefix}entries`";
		$sql[5]['special_return'] = TRUE;
		$sql[5]['execute'] = <<< ENTRY_INDEXING
			CREATE INDEX
				updt_disp_idx
			ON
				`{$db_prefix}entries` (updated, display);
ENTRY_INDEXING;

		//--- FULTEXT Search Check
		$sql[6]['test'] = "SELECT force_execute FROM {$db_prefix}entries";
		$sql[6]['special_function'] = 'idx_chk';
		$sql[6]['special_chk_query'] = "SHOW INDEX FROM `{$db_prefix}entries`";
		$sql[6]['special_chk_value'] = 'title';
		$sql[6]['special_action_query'] = FALSE;
		$sql[6]['special_return'] = FALSE;
		$sql[6]['execute'] = <<< ENTRY_SEARCH
			ALTER TABLE {$db_prefix}entries ADD FULLTEXT(title,body,more);
ENTRY_SEARCH;

		//--- RBL
		$sql[7]['test'] = "SELECT COUNT(id) FROM {$db_prefix}blocked";
		$sql[7]['execute'] = <<< RBL_BLOCKED
				CREATE TABLE IF NOT EXISTS `{$db_prefix}rbl_blocked` (
				  `id` int(8) NOT NULL auto_increment,
				  `ip` char(15) NOT NULL default '',
				  `visits` int(8) NOT NULL default '0',
				  `lastseen` datetime NOT NULL,
				  `services` char(255) NOT NULL default '',
				  `referer` char(255) default NULL,
				  `whitelist` enum('0','1') NOT NULL default '0',
				  PRIMARY KEY (`id`),
				  UNIQUE KEY `ip_idx` (`ip`)
				) TYPE=MyISAM;
RBL_BLOCKED;

		$sql[8]['test'] = "SELECT COUNT(id) FROM {$db_prefix}rbl_keywords";
		$sql[8]['execute'] = <<< RBL_KEYWORDS
				CREATE TABLE IF NOT EXISTS `{$db_prefix}rbl_keywords` (
				  `id` int(8) NOT NULL auto_increment,
				  `keyword` char(20) NOT NULL default '',
				  `occurances` int(8) NOT NULL default '0',
				  `lastseen` datetime NOT NULL,
				  PRIMARY KEY (`id`),
				  UNIQUE KEY `keyword_idx` (`keyword`)
				) TYPE=MyISAM;
RBL_KEYWORDS;

		//--- RBL Keywords
		$sql[9]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='viagra';";
		$sql[9]['exec_empty_result'] = TRUE;
		$sql[9]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('viagra', 0, NOW());";
		$sql[10]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='phentermine';";
		$sql[10]['exec_empty_result'] = TRUE;
		$sql[10]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('phentermine', 0, NOW());";
		$sql[11]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='cialis';";
		$sql[11]['exec_empty_result'] = TRUE;
		$sql[11]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('cialis', 0, NOW());";
		$sql[12]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='adipex';";
		$sql[12]['exec_empty_result'] = TRUE;
		$sql[12]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('adipex', 0, NOW());";
		$sql[13]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='hydrocodone';";
		$sql[13]['exec_empty_result'] = TRUE;
		$sql[13]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('hydrocodone', 0, NOW());";
		$sql[14]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='xanax';";
		$sql[14]['exec_empty_result'] = TRUE;
		$sql[14]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('xanax', 0, NOW());";
		$sql[15]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='vicodin';";
		$sql[15]['exec_empty_result'] = TRUE;
		$sql[15]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('vicodin', 0, NOW());";
		$sql[16]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='fioricet';";
		$sql[16]['exec_empty_result'] = TRUE;
		$sql[16]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('fioricet', 0, NOW());";
		$sql[17]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='valium';";
		$sql[17]['exec_empty_result'] = TRUE;
		$sql[17]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('valium', 0, NOW());";
		$sql[18]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='poker';";
		$sql[18]['exec_empty_result'] = TRUE;
		$sql[18]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('poker', 0, NOW());";
		$sql[19]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='holdem';";
		$sql[19]['exec_empty_result'] = TRUE;
		$sql[19]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('holdem', 0, NOW());";
		$sql[20]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='albuterol';";
		$sql[20]['exec_empty_result'] = TRUE;
		$sql[20]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('albuterol', 0, NOW());";
		$sql[21]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='lorazepam';";
		$sql[21]['exec_empty_result'] = TRUE;
		$sql[21]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('lorazepam', 0, NOW());";
		$sql[22]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='ringtone';";
		$sql[22]['exec_empty_result'] = TRUE;
		$sql[22]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('ringtone', 0, NOW());";
		$sql[23]['test'] = "SELECT keyword FROM {$db_prefix}rbl_keywords WHERE keyword='mp3city';";
		$sql[23]['exec_empty_result'] = TRUE;
		$sql[23]['execute'] = "INSERT INTO `{$db_prefix}rbl_keywords` (keyword, occurances, lastseen) VALUES ('mp3city', 0, NOW());";

		//--- More Improved Entry Indexing
		$sql[24]['test'] = "SELECT force_execute FROM {$db_prefix}entries";
		$sql[24]['special_function'] = 'idx_chk';
		$sql[24]['special_chk_query'] = "SHOW INDEX FROM `{$db_prefix}entries`";
		$sql[24]['special_chk_value'] = 'disp_updt_idx';
		$sql[24]['special_action_query'] = "SHOW INDEX FROM `{$db_prefix}entries`";
		$sql[24]['special_return'] = FALSE;
		$sql[24]['execute'] = <<< ENTRY_INDEXING2
			CREATE INDEX
				disp_updt_idx
			ON
				`{$db_prefix}entries` (display,updated);
ENTRY_INDEXING2;

		//--- Trackbacks
		$sql[25]['test'] = "SELECT COUNT(trackback) FROM {$db_prefix}comments";
		$sql[25]['execute'] = <<< TB_COMMENT
			ALTER TABLE
				{$db_prefix}comments
			ADD COLUMN
				trackback enum('0','1') NOT NULL default '0'
			AFTER
				comment;
TB_COMMENT;

		$sql[26]['test'] = "SELECT COUNT(tb_url) FROM {$db_prefix}entries";
		$sql[26]['execute'] = <<< TB_ENTRY
			ALTER TABLE
				{$db_prefix}entries
			ADD COLUMN
				tb_url varchar(100) NOT NULL DEFAULT ''
			AFTER
				more;
TB_ENTRY;

		if (defined('RBL_AKISMET_AUTODEL') && RBL_AKISMET_AUTODEL === TRUE) {
		$sql[27]['test'] = "SELECT force_execute FROM {$db_prefix}rbl_blocked";
		$sql[27]['execute'] = <<< RBL_CLEAN
			DELETE FROM
				{$db_prefix}rbl_blocked
			WHERE
				SUBSTRING(services,1,7)='akismet';
RBL_CLEAN;

		$sql[28]['test'] = "SELECT force_execute FROM {$db_prefix}rbl_blocked";
		$sql[28]['execute'] = <<< RBL_OPT
			OPTIMIZE TABLE {$db_prefix}rbl_blocked;
RBL_OPT;
		}

		//--- More Improved Entry Indexing Again
		$sql[29]['test'] = "SELECT force_execute FROM {$db_prefix}entries";
		$sql[29]['special_function'] = 'idx_chk';
		$sql[29]['special_chk_query'] = "SHOW INDEX FROM `{$db_prefix}entries`";
		$sql[29]['special_chk_value'] = 'name_idx';
		$sql[29]['special_action_query'] = "SHOW INDEX FROM `{$db_prefix}entries`";
		$sql[29]['special_return'] = FALSE;
		$sql[29]['execute'] = <<< TOPIC_INDEXING
			CREATE INDEX
				name_idx
			ON
				`{$db_prefix}topics` (name);
TOPIC_INDEXING;

		//--- Improved Comment Indexing
		$sql[30]['test'] = "SELECT force_execute FROM {$db_prefix}comments";
		$sql[30]['special_function'] = 'idx_chk';
		$sql[30]['special_chk_query'] = "SHOW INDEX FROM `{$db_prefix}comments`";
		$sql[30]['special_chk_value'] = 'ord_idx';
		$sql[30]['special_action_query'] = "DROP INDEX ord_idx ON `{$db_prefix}comments`";
		$sql[30]['special_return'] = TRUE;
		$sql[30]['execute'] = <<< ENTRY_INDEXING
			CREATE INDEX
				ord_idx
			ON
				`{$db_prefix}comments` (eid,pid,display,timestamp);
ENTRY_INDEXING;



		//--- Process Updates
		$i = 0;
		foreach ($sql as $query) {
			$special = TRUE;
			$q_stat = $dbObj->query($query['test']);
			if (!$q_stat || (isset($query['exec_empty_result']) && $query['exec_empty_result'] && $dbObj->getResultCnt() == 0)) {

				if (isset($query['special_function']) && isset($query['special_chk_query'])) {
					$special = $query['special_function']($dbObj, $query['special_chk_query'], $query['special_chk_value'], $query['special_action_query'], $query['special_return']);
				}

				if ($special) {
					if (!$dbObj->query($query['execute'])) {
						$stat[$i] = FALSE;
						echo '<p><strong>DB Error:</strong> ' . $dbObj->getError() . "</p>\n";
					} else {
						$stat[$i] = TRUE;
					}
				} else {
					$stat[$i] = TRUE;
				}
			} else {
				$stat[$i] = TRUE;
			}
			++$i;
		}
		$stat[1] = TRUE; //force comment_ip TRUE

		return $stat;
	}

function idx_chk(&$dbObj, $chk_query, $chk_value, $action_query = FALSE, $return = FALSE) {
	if (!$dbObj->query($chk_query)) {
		echo '<p><strong>DB Error:</strong> ' . $dbObj->getError() . "</p>\n";
	} else {
		while ($row = $dbObj->getRow()) {
			if ($row['Key_name'] === $chk_value) {
				if ($action_query) {
					if (!$dbObj->query($action_query)) {
						echo '<p><strong>DB Error:</strong> ' . $dbObj->getError() . "</p>\n";
					}
				}
				return $return;
			}
		}
	}

	return !$return;
}
?>
