<?php
/*
 This program is distributed under the terms of the GNU General Public License.
 See the README & COPYING files for more information.
 Copyright (C) 2004-2005  Kevin L. Papendick <kevinp@polarlava.com>
*/

	//--- Includes
	require_once(LIB_PATH . 'PbBase_class.php');

	class PbTopic extends PbBase
	{
		//--- Class Variables
		var $name;
		var $icon;
		var $topic_exists;



		//-----------------------------------------------
		//--- CONSTRUCTOR
		//--- PURPOSE:
		//---   Create blog topic object
		//--- PARAMETERS: table prefix (optional)
		//---					topic id (optional)
		//--- RETURNS: nothing
		//-----------------------------------------------
		function PbTopic($prefix = 'wl_', $id = '')
		{

			$this->PbBase($prefix);

			if (is_int($id)) {
				//--- Retrieve Data
				$this->getTopicData($id);
			}

		}


		//-----------------------------------------------
		//-----------------------------------------------
		//--- SET METHODS -------------------------------
		//-----------------------------------------------
		//-----------------------------------------------


		//-----------------------------------------------
		//--- METHOD: setTopicExists
		//--- PURPOSE: flag value indicates if topic
		//---				data exists for the given ID
		//--- PARAMETERS: TRUE/FALSE
		//--- RETURNS: nothing
		//-----------------------------------------------
		function setTopicExists($a)
		{
			$this->topic_exists = $a;
		}

		//-----------------------------------------------
		//--- METHOD: setName
		//--- PURPOSE: set topic name
		//--- PARAMETERS: topic name
		//--- RETURNS: nothing
		//-----------------------------------------------
		function setName($a)
		{
			$this->name = $a;
		}

		//-----------------------------------------------
		//--- METHOD: setIcon
		//--- PURPOSE: set topic icon
		//--- PARAMETERS: topic icon
		//--- RETURNS: nothing
		//-----------------------------------------------
		function setIcon($a)
		{
			$this->icon = $a;
		}






		//-----------------------------------------------
		//-----------------------------------------------
		//--- GET METHODS -------------------------------
		//-----------------------------------------------
		//-----------------------------------------------


		//-----------------------------------------------
		//--- METHOD: getTopicData
		//--- PURPOSE: gets  Topic data
		//--- PARAMETERS: id (optional)
		//--- RETURNS: TRUE on success
		//---          FALSE of failure
		//-----------------------------------------------
		function getTopicData($id = '')
		{
			//--- Check for ID
			if (!isset($id)) {
				$id = $this->getId();
			}

			//--- Query
			$query = "SELECT
							tid,
							name,
							icon
						 FROM
					 		{$this->prefix}topics
					 	 WHERE
					 	 	tid='%i'";
			$query_data = array($id);

			//--- Issue Query
			if ($this->dbObj->safeQuery($query, $query_data)) {

				//--- Check for results
				if ($this->dbObj->result_cnt > 0) {

					//--- Retrieve Results
					while ($this->dbObj->getRow()) {
						$this->setId($this->dbObj->row['tid']);
						$this->setName($this->dbObj->row['name']);
						$this->setIcon($this->dbObj->row['icon']);
					}
					$this->setTopicExists(TRUE);

				} else {
					$this->setTopicExists(FALSE);
				}

				$stat = TRUE;

			} else {

				//--- Query Error
				echo $this->dbObj->getError();
				$stat = FALSE;
			}
				return $stat;
		}


		//-----------------------------------------------
		//--- METHOD: getName
		//--- PURPOSE: get topic name
		//--- PARAMETERS: none
		//--- RETURNS: topic name
		//-----------------------------------------------
		function getName()
		{
			return $this->name;
		}

		//-----------------------------------------------
		//--- METHOD: getIcon
		//--- PURPOSE: get topic icon
		//--- PARAMETERS: none
		//--- RETURNS: topic icon
		//-----------------------------------------------
		function getIcon()
		{
			return $this->icon;
		}

		//-----------------------------------------------
		//--- METHOD: getTopicExists
		//--- PURPOSE: flag value indicates if entry
		//---				data exists for the given ID
		//--- PARAMETERS: none
		//--- RETURNS: TRUE/FALSE
		//-----------------------------------------------
		function getTopicExists()
		{
			return $this->topic_exists;
		}




		//-----------------------------------------------
		//-----------------------------------------------
		//--- OTHER METHODS -----------------------------
		//-----------------------------------------------
		//-----------------------------------------------


		//-----------------------------------------------
		//--- METHOD: updateTopic
		//--- PURPOSE: update topic in the database
		//--- PARAMETERS: none
		//--- RETURNS: TRUE on success
		//---          FALSE on failure
		//-----------------------------------------------
		function updateTopic()
		{
			if (!$this->getId() > 0) {
				return FALSE;
			}

			$query = "UPDATE
					 		{$this->prefix}topics
						SET
							name='%s',
							icon='%s'
						WHERE
							tid='%i'";
			$query_data = array($this->getName(), $this->getIcon(), $this->getId());

			$this->setTopicExists(TRUE);
			return $this->writeDb($query, $query_data);

		}

		//-----------------------------------------------
		//--- METHOD: insertTopic
		//--- PURPOSE: insert topic in the database
		//--- PARAMETERS: none
		//--- RETURNS: TRUE on success
		//---          FALSE on failure
		//-----------------------------------------------
		function insertTopic()
		{
			$query = "INSERT INTO
							{$this->prefix}topics
							(
							 name,
							 icon
							)
						VALUES
							(
							 '%s',
							 '%s'
							)";
			$query_data = array($this->getName(), $this->getIcon());

			$stat = $this->writeDb($query, $query_data);
			if ($stat) {
				if (DB_CONNECT === 'mysqli') {
					$this->setId(mysqli_insert_id($this->dbObj->getDb()));
				} else {
					$this->setId(mysql_insert_id());
				}
				$this->setTopicExists($stat);
			}
			return $stat;
		}

		//-----------------------------------------------
		//--- METHOD: deleteTopic
		//--- PURPOSE: update entry data in the database
		//--- PARAMETERS: none
		//--- RETURNS: TRUE on success
		//---          FALSE on failure
		//-----------------------------------------------
		function deleteTopic()
		{
			if (!$this->getId() > 0) {
				return FALSE;
			}

			$query = "DELETE FROM
					 		{$this->prefix}topics
						WHERE
							tid='%i'";
			$query_data = array($this->getId());

			$this->setTopicExists(FALSE);
			return $this->writeDb($query, $query_data);
		}

	} //end of class
?>