<?php
/*
 This program is distributed under the terms of the GNU General Public License.
 See the README & COPYING files for more information.
 Copyright (C) 2004-2009  Kevin L. Papendick <kevinp@polarlava.com>
*/

	//--- Includes
	require_once('./config/config.php');
	require(LIB_PATH . 'PolarBlog_class.php');
	require_once(LIB_PATH . 'Localization_class.php');

	//--- Create Blog & Language Objects
	$blog = new PolarBlog(DB_PREFIX, $rbl_services);
	$langObj = new Localization(I18N_LANG, './lang/');

	//--- Personal Weblog Compatibility
	// $mode, $eid, $tid, $password, $name, $icon, $value, $title, $body;
	// $more, $update, $offset, $search, $topic, $delopt, $before, $start, $date;
	if (isset($_GET[DB_PREFIX . 'eid'])) { $_GET['eid'] = $_GET[DB_PREFIX . 'eid']; }
	if (isset($_GET[DB_PREFIX . 'topic'])) { $_GET['tid'] = $_GET[DB_PREFIX . 'topic']; }
	if (isset($_GET[DB_PREFIX . 'date'])) { $_GET['date'] = $_GET[DB_PREFIX . 'date']; }


	//--- Cancel
	if (isset($_POST['cancel'])) {
		unset($_POST['id']);
		unset($_POST['eid']);
		unset($_POST['tid']);
		unset($_POST['start']);
	}

	//--- Untaint Variables
	$clean = array();
	$clean['start'] = (isset($_POST['start']) && preg_match('/^\d{1,5}$/', (string) $_POST['start'])) ? (int) $_POST['start'] : 0;
	$clean['start'] = (isset($_GET['start']) && preg_match('/^\d{1,5}$/', (string) $_GET['start'])) ? (int) $_GET['start'] : $clean['start'];
	$clean['start'] = (isset($_GET['recent'])) ? 0 : $clean['start'];
	$clean['eid'] = (isset($_GET['eid']) && preg_match('/^\d{1,5}$/', (string) $_GET['eid'])) ? (int) $_GET['eid'] : FALSE;
	$clean['eid'] = (isset($_POST['eid']) && preg_match('/^\d{1,5}$/', (string) $_POST['eid'])) ? (int) $_POST['eid'] : $clean['eid'];
	$clean['tid'] = (isset($_GET['tid']) && preg_match('/^\d{1,2}$/', (string) $_GET['tid'])) ? (int) $_GET['tid'] : FALSE;
	$clean['tid'] = (isset($_POST['tid']) && preg_match('/^\d{1,2}$/', (string) $_POST['tid'])) ? (int) $_POST['tid'] : $clean['tid'];
	$clean['id'] = (isset($_GET['id']) && preg_match('/^\d{1,2}$/', (string) $_GET['id'])) ? (int) $_GET['id'] : FALSE;
	$clean['id'] = (isset($_POST['id']) && preg_match('/^\d{1,2}$/', (string) $_POST['id'])) ? (int) $_POST['id'] : $clean['id'];
	$clean['cid'] = (isset($_GET['cid']) && preg_match('/^\d{1,5}$/', (string) $_GET['cid'])) ? (int) $_GET['cid'] : FALSE;
	$clean['cid'] = (isset($_POST['cid']) && preg_match('/^\d{1,5}$/', (string) $_POST['cid'])) ? (int) $_POST['cid'] : $clean['cid'];
	$clean['pid'] = (isset($_GET['pid']) && preg_match('/^\d{1,5}$/', (string) $_GET['pid'])) ? (int) $_GET['pid'] : FALSE;
	$clean['pid'] = (isset($_POST['pid']) && preg_match('/^\d{1,5}$/', (string) $_POST['pid'])) ? (int) $_POST['pid'] : $clean['pid'];
	$clean['search'] = (isset($_POST['search']) && ctype_print($_POST['search'])) ? $_POST['search'] : FALSE;
	$clean['index'] = (isset($_GET['index']) && preg_match('/^-?\d{1,5}$/', (string) $_GET['index'])) ? (int) $_GET['index'] : FALSE;
	$clean['date'] = (isset($_GET['date']) && preg_match('/^\d{8}$/', (string) $_GET['date'])) ? (int) $_GET['date'] : FALSE;
	$clean['month'] = (isset($_GET['m']) && preg_match('/^\d{1,2}$/', (string) $_GET['m'])) ? (int) $_GET['m'] : date('m');
	$clean['year'] = (isset($_GET['y']) && preg_match('/^\d{4}$/', (string) $_GET['y'])) ? (int) $_GET['y'] : date('Y');
	$clean['linebreak'] = (isset($_POST['linebreak']) && preg_match('/^\d{1}$/', (string) $_POST['linebreak'])) ? 1 : 0;
	$clean['user'] = (isset($_POST['user']) && ctype_graph($_POST['user'])) ? strip_tags($_POST['user']) : FALSE;
	$clean['passwd'] = (isset($_POST['passwd']) && ctype_graph($_POST['passwd'])) ? strip_tags($_POST['passwd']) : FALSE;
	$clean['dupe_id'] = (isset($_POST['dupe_id']) && preg_match('/^\w{32}$/', (string) $_POST['dupe_id'])) ? $_POST['dupe_id'] : FALSE;
	$clean['display'] = (isset($_POST['display']) && preg_match('/^\d{1}$/', (string) $_POST['display'])) ? 1 : 0;
	$clean['allow_comments'] = (isset($_POST['allow_comments']) && preg_match('/^\d{1}$/', (string) $_POST['allow_comments'])) ? 1 : 0;
	$clean['update_timestamp'] = (isset($_POST['update_timestamp']) && preg_match('/^\d{1}$/', (string) $_POST['update_timestamp'])) ? TRUE : FALSE;
	$clean['create_timestamp'] = (isset($_POST['create_timestamp']) && preg_match('/^\d{1}$/', (string) $_POST['create_timestamp'])) ? TRUE : FALSE;
	$clean['title'] = (isset($_POST['title'])) ? strip_tags($_POST['title'], COMMENT_TAGS) : '';
	$clean['time_adj_dir'] = (isset($_POST['time_adj_dir']) && $_POST['time_adj_dir'] == '-') ? $_POST['time_adj_dir'] : '+';
	$clean['time_adj_hour'] = (isset($_POST['time_adj_hour']) && ctype_digit($_POST['time_adj_hour'])) ? $_POST['time_adj_hour'] : 0;
	$clean['time_adj_min'] = (isset($_POST['time_adj_min']) && ctype_digit($_POST['time_adj_min'])) ? $_POST['time_adj_min'] : 0;
	$clean['edit'] = (isset($_POST['edit'])) ? TRUE : FALSE;
	$clean['ping'] = (isset($_POST['ping'])) ? TRUE : FALSE;
	$clean['body'] = (isset($_POST['body'])) && $_POST['body'] ? $_POST['body'] : '';
	$clean['more'] = (isset($_POST['more'])) && $_POST['more'] ? $_POST['more'] : '';
	$clean['tb_url'] = (isset($_POST['tb_url']) && preg_match('{\A[a-z0-9\-=_/.,?%&:~@+`\[\]\\\\!^*()_\{\}|\'"<>]+\z}i', (string) $_POST['tb_url'])) ? strip_tags($_POST['tb_url']) : FALSE;
	$clean['tb_resend'] = (isset($_POST['tb_resend'])) ? TRUE : FALSE;
	$clean['login_req'] = (isset($_POST['login_req'])) ? TRUE : FALSE;
	$clean['login'] = (isset($_GET['login'])) ? TRUE : FALSE;
	$clean['hint_me'] = (isset($_GET['hint_me']) && MAIL_TYPE != FALSE) ? TRUE : FALSE;
	$clean['hint_req'] = (isset($_POST['hint_req']) && MAIL_TYPE != FALSE) ? TRUE : FALSE;
	$clean['logout'] = (isset($_GET['logout'])) ? TRUE : FALSE;
	$clean['password'] = (isset($_POST['password']) && ctype_graph($_POST['password'])) ? strip_tags($_POST['password']) : FALSE;
	$clean['password2'] = (isset($_POST['password2']) && ctype_graph($_POST['password2'])) ? strip_tags($_POST['password2']) : FALSE;
	$clean['hint'] = (isset($_POST['hint'])) ? strip_tags($_POST['hint']) : FALSE;
	$pattern = '/^((?:(?:(?:[a-zA-Z0-9][\.\-\+_]?)*)[a-zA-Z0-9])+)\@((?:(?:(?:[a-zA-Z0-9][\.\-_]?){0,62})[a-zA-Z0-9])+)\.([a-zA-Z0-9]{2,6})$/';
	$clean['email'] = (isset($_POST['email']) && preg_match($pattern, (string) $_POST['email'])) ? $_POST['email'] : FALSE;
	$clean['pop3_alt_email'] = (isset($_POST['pop3_alt_email']) && preg_match($pattern, (string) $_POST['pop3_alt_email'])) ? $_POST['pop3_alt_email'] : FALSE;
	$clean['post_by'] = (isset($_POST['post_by'])) ? strip_tags($_POST['post_by']) : FALSE;
	$clean['pop3'] = (isset($_POST['pop3']) && preg_match('/^[0|1]?$/', (string) $_POST['pop3'])) ? $_POST['pop3'] : '0';
	$clean['post_entry'] = (isset($_POST['post_entry']) && preg_match('/^[0|1]?$/', (string) $_POST['post_entry'])) ? $_POST['post_entry'] : '0';
	$clean['change_pw'] = (isset($_GET['change_pw']) && preg_match('/^[0|1]?$/', (string) $_GET['change_pw'])) ? TRUE : FALSE;
	$clean['pw_update'] = (isset($_POST['pw_update'])) ? TRUE : FALSE;
	$clean['post_comment'] = (isset($_POST['post_comment']) && preg_match('/^[0|1]?$/', (string) $_POST['post_comment'])) ? $_POST['post_comment'] : '0';
	$clean['user_admin'] = (isset($_POST['user_admin']) && preg_match('/^[0|1]?$/', (string) $_POST['user_admin'])) ? $_POST['user_admin'] : '0';
	$clean['name'] = (isset($_POST['name'])) ? strip_tags($_POST['name']) : FALSE;
	$clean['icon'] = (isset($_POST['icon']) && preg_match('/^[\w:\/.-~]+$/', (string) $_POST['icon'])) ? strip_tags($_POST['icon']) : FALSE;
	$clean['url'] = (isset($_POST['url']) && preg_match('/^[\w:\/.-~&#]+$/', (string) $_POST['url'])) ? strip_tags($_POST['url']) : FALSE;
	$clean['comment'] = (isset($_POST['comment']) && is_string($_POST['comment'])) ? strip_tags($_POST['comment'], COMMENT_TAGS) : '';
	$edit_modes = array(
					'update',
					'insert',
					'user_edit',
					'user_update',
					'user_insert',
					'topic_edit',
					'topic_insert',
					'topic_update',
					'topic_delete',
					'comment_insert',
					'comment_update'
				  );
	$clean['edit_mode'] = ($clean['edit'] && isset($_POST['edit_mode']) && in_array($_POST['edit_mode'], $edit_modes)) ? $_POST['edit_mode'] : FALSE;
	$clean['edit_mode'] = (isset($_POST['user_delete']) && $_POST['user_delete'] === $langObj->get('DELETE_USER')) ? 'user_delete' : $clean['edit_mode'];
	$clean['edit_mode'] = (isset($_POST['topic_delete']) && ($_POST['topic_delete'] === $langObj->get('DELETE_TOPIC'))) ? 'topic_delete' : $clean['edit_mode'];

	$admin_modes = array(
					'edit',
					'add',
					'del',
					'users',
					'topics',
					'edit_comment',
					'del_comment',
					'rbl_bl',
					'rbl_wl',
					'rbl_admin',
					'tb_on',
					'tb_off'
				   );
	$clean['admin'] = (isset($_GET['admin']) && in_array($_GET['admin'], $admin_modes)) ? $_GET['admin'] : FALSE;
	$clean['admin'] = (isset($_POST['admin']) && in_array($_POST['admin'], $admin_modes)) ? $_POST['admin'] : $clean['admin'];
	$cancel_modes = array(
						'topics',
						'users'
					);
	$clean['admin'] = (isset($_POST['cancel']) && isset($_POST['cancel_mode']) && in_array($_POST['cancel_mode'], $admin_modes)) ? $_POST['cancel_mode'] : $clean['admin'];
	$rbl_admin_modes = array(
						'ip_edit',
						'keyword_edit',
						'comment_action'
					);
	$clean['rbl_admin_action'] = (isset($_GET['rbl_admin_action']) && in_array($_GET['rbl_admin_action'], $rbl_admin_modes)) ? $_GET['rbl_admin_action'] : FALSE;
	$clean['rbl_admin_action'] = (isset($_POST['rbl_admin_action']) && in_array($_POST['rbl_admin_action'], $rbl_admin_modes)) ? $_POST['rbl_admin_action'] : $clean['rbl_admin_action'];
	$clean['rbl_ip'] = (isset($_POST['rbl_ip'])) ? trim($_POST['rbl_ip']) : FALSE; //verified below
	$clean['rbl_keyword'] = (isset($_POST['rbl_keyword']) && ctype_print(trim($_POST['rbl_keyword']))) ? trim($_POST['rbl_keyword']) : FALSE;
	//--- Untaint Variables - END

	$non_stat_msg = TRUE;

	//--- Verify Current/Login/Logout
	if (!$clean['logout'] && isset($_SESSION['login']) && $_SESSION['login'] === TRUE && (isset($_SESSION['magic']) && $_SESSION['magic'] !== FALSE)) {
		$stat = $blog->checkLogin('', $_SESSION['magic'], TRUE);
		$clean['login'] = !$stat;
	} elseif ($clean['login_req']) {
		$blog->checkLogin($clean['user'], $clean['passwd']);
		if (!$_SESSION['login']) {
			$clean['login'] = TRUE; //force relogin
		}
	} elseif ($clean['logout']) {
		$_SESSION['login'] = FALSE;
		$_SESSION['magic'] = FALSE;
		session_destroy();
	}

	if (!isset($_SESSION['ip'])) {
		$_SESSION['ip'] = $blog->getUserIp();
		$_SESSION['referrer'] = (isset($_SERVER['HTTP_REFERER'])) ? $_SERVER['HTTP_REFERER'] : 'unknown';
	}

	//--- Admin Functions
	$admin_action = FALSE;
	$entry_stat = FALSE;
	if (!$clean['login'] && isset($_SESSION['login']) && $_SESSION['login'] === TRUE) {
		//--- Edit Entry
		if ($clean['admin'] === 'edit' || $clean['admin'] === 'add') {
			$blog->setEditDisplay($clean['eid']);
			$admin_action = TRUE;

		} elseif ($clean['edit_mode'] === 'update' || $clean['edit_mode'] === 'insert') {
			//--- Update/Insert Entry
			if ($clean['edit_mode'] === 'update' || (isset($_SESSION['dupe_id']) && $clean['dupe_id'] === $_SESSION['dupe_id'])) {
				$tb_send = ($clean['edit_mode'] === 'insert' || ($clean['tb_url'] && $clean['tb_resend'])) ? TRUE : FALSE;
				$non_stat_msg = $blog->setEntry($clean['edit_mode'], $clean['eid'], $clean['title'], $clean['tid'], $clean['linebreak'], $clean['display'], $clean['allow_comments'], $clean['body'], $clean['more'], $clean['update_timestamp'], $clean['create_timestamp'], $clean['time_adj_dir'], $clean['time_adj_hour'], $clean['time_adj_min'], $clean['ping'], $clean['tb_url'], $tb_send);
				$clean['tid'] = FALSE;
				if ($clean['edit_mode'] === 'insert') {
					$clean['eid'] = $blog->getNewEid();
				}
				$entry_stat = TRUE;
			} else {
				$non_stat_msg = FALSE;
				$blog->setDisplayMsg($langObj->get('DUPLICATE_ENTRY_MSG'), 'FAIL_DISPLAY_MSG', $langObj->get('TRY_AGAIN'));
			}
			unset($_SESSION['dupe_id']);

		} elseif ($clean['admin'] === 'del' && isset($clean['eid'])) {
			//--- Delete Entry
			$userObj = new PbEntry($blog->getDbPrefix(), $clean['eid']);
			$userObj->deleteEntry($clean['eid']);
			$clean['eid'] = FALSE;


		//--- USER Management
		} elseif ($clean['admin'] === 'users') {
			//--- User Select
			$blog->setEditUserDisplay($clean['id']);
			$admin_action = TRUE;
		} elseif ($clean['edit_mode'] === 'user_edit') {
			//--- User Edit
			$clean['id'] = (!$clean['id']) ? -1 : $clean['id']; //new user
			$blog->setEditUserDisplay($clean['id']);
			$admin_action = TRUE;
		} elseif ($clean['edit_mode'] === 'user_update' || $clean['edit_mode'] === 'user_insert' || $clean['edit_mode'] === 'user_delete') {
			//--- User Update/Insert
			require_once(LIB_PATH . 'PbUser_class.php');
			$userObj = new PbUser($blog->getDbPrefix(), $clean['id']);
			$userObj->setUser($clean['user']);
			$userObj->setPassword($clean['password']);
			$userObj->setHint($clean['hint']);
			$userObj->setEmail($clean['email']);
			$userObj->setPostBy($clean['post_by']);
			$userObj->setPop3($clean['pop3']);
			$userObj->setPop3AltEmail($clean['pop3_alt_email']);
			$userObj->setPostEntry($clean['post_entry']);
			$userObj->setPostComment($clean['post_comment']);
			$userObj->setAdmin($clean['user_admin']);
			if ($clean['edit_mode'] === 'user_delete') {
				$userObj->deleteUser();
			} elseif ($clean['edit_mode'] === 'user_update') {
				$userObj->updateUser();
			} elseif ($clean['edit_mode'] === 'user_insert') {
				$userObj->insertUser();
			} else {
				die('Invalid user mode');
			}

		//--- TOPIC Management
		} elseif ($clean['admin'] === 'topics') {
			//--- Topic Select
			$blog->setEditTopicsDisplay($clean['tid']);
			$admin_action = TRUE;
		} elseif ($clean['edit_mode'] === 'topic_edit') {
			//--- Topic Edit
			$clean['tid'] = (!$clean['tid']) ? -1 : $clean['tid']; //new topic
			$blog->setEditTopicsDisplay($clean['tid']);
			$admin_action = TRUE;
		} elseif ($clean['edit_mode'] === 'topic_update' || $clean['edit_mode'] === 'topic_insert' || $clean['edit_mode'] === 'topic_delete') {
			//--- Topic Update/Insert
			require_once(LIB_PATH . 'PbTopic_class.php');
			$topicObj = new PbTopic($blog->getDbPrefix(), $clean['tid']);
			$topicObj->setName($clean['name']);
			$topicObj->setIcon($clean['icon']);
			if ($clean['edit_mode'] === 'topic_delete') {
				$topicObj->deleteTopic();
			} elseif ($clean['edit_mode'] === 'topic_update') {
				$topicObj->updateTopic();
			} elseif ($clean['edit_mode'] === 'topic_insert') {
				$topicObj->insertTopic();
			} else {
				die('Invalid topic mode');
			}

			//--- Reset Topics
			$clean['tid'] = FALSE;
			$blog->setTopics();

		//--- COMMENT Management
		} elseif ($clean['admin'] === 'edit_comment') {
			$admin_action = TRUE;
			$commentObj = new PbComment($blog->getDbPrefix(), $clean['cid']);
			if ($commentObj->getIsTrackback()) {
				$clean['cid'] = FALSE;
				$clean['admin'] = FALSE;
				$admin_action = FALSE;
				$non_stat_msg = FALSE;
				$blog->setDisplayMsg($langObj->get('TB_NO_EDIT'), 'FAIL_DISPLAY_MSG');
			} else {
				$blog->setEditCommentDisplay($commentObj);
			}
		} elseif ($clean['admin'] === 'del_comment') {
			$commentObj = new PbComment($blog->getDbPrefix(), $clean['cid']);
			$clean['eid'] = $commentObj->getEid();
			$commentObj->deleteComment();

		//--- TRACKBACK Management
		} elseif ($clean['admin'] === 'tb_on' || $clean['admin'] === 'tb_off') {
			require_once(LIB_PATH . 'PbTrackback.php');
			$tbObj = new PbTrackback($blog->getDbPrefix(), $rbl_services, $clean['cid']);
			$mode = ($clean['admin'] === 'tb_on') ? TRUE : FALSE;
			$tbObj->toggleDisplay($mode);

		//--- RBL Management
		} elseif ($clean['admin'] === 'rbl_admin') {
			if ($clean['rbl_admin_action'] === 'ip_edit') {
				$blog->setRblObj();
				//Add RBL IP
				if ($clean['rbl_ip']) {
					if ($blog->validateIp($clean['rbl_ip'])) {
						$blog->rblObj->setIp($clean['rbl_ip']);
						if (!$blog->rblObj->checkLocalRbl($clean['rbl_ip'])) {
							$blog->rblObj->updateLocalRblDb();
						}
					} else {
						//NOP: Invalid IP
					}
				} else {
					$blog->setRblObj();//Blacklist/Whitelist/Delete IP
					$bl = $wl = $id = NULL;
					foreach (array_keys($_POST) as $v) {
						if (strpos($v, 'bl-') !== FALSE) {
							list($bl, $id) = split('-', $v);
							$blog->rblObj->updateWhitelist(FALSE, (int) $id);
						} elseif (strpos($v, 'wl-') !== FALSE) {
							list($wl, $id) = split('-', $v);
							$blog->rblObj->updateWhitelist(TRUE, (int) $id);
						} elseif (strpos($v, 'del-') !== FALSE) {
							list($wl, $id) = split('-', $v);
							$blog->rblObj->delEntry((int) $id);
						}
					}
				}
			} elseif ($clean['rbl_admin_action'] === 'keyword_edit') {
				$blog->setRblObj();
				if ($clean['rbl_keyword']) {
					$blog->rblObj->addKeyword($clean['rbl_keyword']);
				} else {
					//Delete Keyword
					$id = NULL;
					foreach (array_keys($_POST) as $v) {
						if (strpos($v, 'del-') !== FALSE) {
							list($wl, $id) = split('-', $v);
							$blog->rblObj->delKeyword((int) $id);
						}
					}
				}
			} elseif ($clean['rbl_admin_action'] === 'comment_action') {
				$clean['cids'] = array();
				if (isset($_POST['cids'])) {
					foreach ($_POST['cids'] as $cid) {
						if (!preg_match('/^\d{1,5}$/', (string) $cid)) {
							continue;
						}
						$clean['cids'][] = (int) $cid;
					}
					$commentObj = new PbComment($blog->getDbPrefix(), $clean['cid']);
					if (isset($_POST['comment_display'])) {
						$commentObj->displayComment($clean['cids']);
					} elseif (isset($_POST['comment_delete'])) {
						$commentObj->deleteComment($clean['cids']);
					}
				}
			} elseif ($clean['rbl_admin_action'] !== FALSE) {
				die('Invalid RBL Admin mode');
			}
			$admin_action = TRUE;
			$blog->setRblAdminDisplay();
		} elseif ($clean['admin'] === 'rbl_bl') {
			$commentObj = new PbComment($blog->getDbPrefix(), $clean['cid']);
			$clean['eid'] = $commentObj->getEid();
			$commentObj->setRblObj($blog->getDbPrefix());
			$commentObj->rblObj->updateWhitelist(FALSE, $commentObj->getIp());
		} elseif ($clean['admin'] === 'rbl_wl') {
			$commentObj = new PbComment($blog->getDbPrefix(), $clean['cid']);
			$clean['eid'] = $commentObj->getEid();
			$commentObj->setRblObj($blog->getDbPrefix());
			$commentObj->rblObj->updateWhitelist(TRUE, $commentObj->getIp());
		}
	}

	//--- Standard Display
	if (!$admin_action) {
		//--- Comment Add/Edit/Delete
		if ($clean['edit_mode'] === 'comment_update' || $clean['edit_mode'] === 'comment_insert') {
			require_once(LIB_PATH . 'PbComment_class.php');
			$commentObj = new PbComment($blog->getDbPrefix(), $clean['cid'], $rbl_services);
			$commentObj->setEid($clean['eid']);
			$commentObj->setPid($clean['pid']);
			$commentObj->setName($clean['name']);
			$commentObj->setEmail($clean['email']);
			$commentObj->setUrl($clean['url']);
			$commentObj->setLineBreak($clean['linebreak']);
			$commentObj->setComment($clean['comment']);

			if ($clean['edit_mode'] === 'comment_update') {
				$commentObj->setDisplay($clean['display']);
				$commentObj->updateComment();
			} elseif ($clean['edit_mode'] === 'comment_insert') {
				if(isset($_SESSION['dupe_id']) && $clean['dupe_id'] === $_SESSION['dupe_id']) {
					$commentObj->insertComment();
					$use_rbl = (defined('USE_RBL') && USE_RBL) ? TRUE : FALSE;
					if ($use_rbl && $commentObj->getRblBlocked()) {
						$non_stat_msg = FALSE;
						if ((defined('RBL_SAVE_BLOCKED') && RBL_SAVE_BLOCKED) && !$commentObj->rblObj->getForceBlock()) {
							$msg = $langObj->get('RBL_BLOCKED_SAVED');
						} elseif ($commentObj->getRblBlocked()) {
							$msg = $langObj->get('RBL_BLOCKED_DEL');
						}
						$msg .= '<br /><br /><span class="pb_search_fail">';
						$rbls = $commentObj->rblObj->getRblListed();
						$lpos = array_search('local_rbl', $rbls);
						if ($lpos !== FALSE) {
							$rbls[$lpos] = 'Local RBL';
						}
						$msg .= implode('<br />', $rbls);
						$msg .= '</span>';
						$blog->setDisplayMsg($msg, 'FAIL_DISPLAY_MSG', FALSE, '');
					}
				}
			} else {
				die('Invalid comment mode');
			}

			//--- Reset
			$clean['pid'] = FALSE;
			$clean['cid'] = FALSE;
			unset($_SESSION['dupe_id']);
		}

		//--- Display Setup
		if ($clean['login']) {
			$username = (isset($clean['user'])) ? $clean['user'] : '';
			$blog->setLoginDisplay($username);
		} elseif ($clean['hint_me']) {
			$blog->setHintDisplay();
		} elseif ($clean['change_pw']) {
			$blog->setChangePasswordDisplay();
		} elseif ($clean['hint_req']) {
			$non_stat_msg = FALSE;
			if ($blog->emailHint($clean['user'])) {
				$msg = $langObj->get('PASSWORD_EMAIL_SENT');
				$pre_msg = 'DISPLAY_MSG_SUCCESS';
			} else {
				$msg = $langObj->get('PASSWORD_EMAIL_FAIL');
				$pre_msg = 'FAIL_DISPLAY_MSG';
			}
			$blog->setDisplayMsg($msg, $pre_msg, FALSE, '');
		} elseif (isset($_SESSION['login']) && $_SESSION['login'] && $clean['pw_update']) {
			$non_stat_msg = FALSE;
			if ($clean['password'] === $clean['password2']) {
				require_once(LIB_PATH . 'PbUser_class.php');
				$userObj = new PbUser($blog->getDbPrefix(), (int) $_SESSION['uid']);
				$userObj->setPassword($clean['password']);
				$userObj->setHint($clean['hint']);

				if ($userObj->updateUserPassword()) {
					$msg = $langObj->get('PASSWORD_UPDATED');
					$pre_msg = 'DISPLAY_MSG_SUCCESS';
				} else {
					$msg = $langObj->get('PASSWORD_UPDATE_FAIL');
					$pre_msg = 'FAIL_DISPLAY_MSG';
				}
			} else {
				$msg = $langObj->get('PASSWORD_MISMATCH');
				$pre_msg = 'FAIL_DISPLAY_MSG';
			}
			$blog->setDisplayMsg($msg, $pre_msg, FALSE, '');
		} elseif ($clean['index']) {
			if (defined('USE_ARCHIVE_CAL') && USE_ARCHIVE_CAL && $clean['index'] == -1) {
				$blog->buildIndexCalendar($clean['year'], $clean['month']);
			} else {
				$clean['index'] = ($clean['index'] == 1 || $clean['index'] == -1) ? 0 : $clean['index']; //move index flag value(1) to start value (0)
				$blog->setIndexDisplay($clean['index']);
			}
		} elseif ($clean['eid'] && is_int($clean['pid'])) {
			$reply_mode = TRUE;
			if ($clean['pid'] == 0) {
				$blog->setDisplay($clean['start'], $clean['eid'], $clean['date'], $clean['tid'], $clean['search'], FALSE, TRUE);
				$reply_mode = FALSE;
			}
			$blog->setAddCommentDisplay($clean['eid'], $clean['pid'], $clean['cid'], $reply_mode);
		} else {
			$blog->setDisplay($clean['start'], $clean['eid'], $clean['date'], $clean['tid'], $clean['search']);
		}

		//--- Calendar Display
		$blog->setAccessoryDisplay($clean['month'], $clean['year']);
	}

	//--- Main Display
	echo $blog->getAccessoryDisplay();
	if ($non_stat_msg) {
		if ($entry_stat) {
			echo $blog->getDisplayMsg();
		}
		echo $blog->getDisplay();
	} else {
		echo $blog->getDisplayMsg();
	}
?>
