<?php
/*
 This program is distributed under the terms of the GNU General Public License.
 See the README & COPYING files for more information.
 Copyright (C) 2005  Kevin L. Papendick <kevinp@polarlava.com>
*/
	//--- Includes
	$_SERVER['HTTP_HOST'] = (PHP_SAPI === 'cli') ? '' : $_SERVER['HTTP_HOST'];
	require_once('config/config.php');
	if (!defined('POP3_MODE') || POP3_MODE === FALSE || POP3_MODE != PHP_SAPI) { exit; }
	require_once(LIB_PATH . 'pop3.php');
	require_once(LIB_PATH . 'PbEntry_class.php');
	require_once(LIB_PATH . 'class.phpmailer.php');
	require_once(LIB_PATH . 'Localization_class.php');

	//--- Setup
	$entry = new PbEntry(DB_PREFIX);
	$pop3 = new pop3_class;
	$pop3->hostname = POP3_HOST;
	$pop3->port = POP3_PORT;
	$user = POP3_USER;
	$password = POP3_PASSWD;
	$pop3->debug = 0;
	$pop3->html_debug = 1;
	$debug = FALSE;
	$debug_entry_object = FALSE;

	//--- Valid Users
	$users = array();
	get_pop3_users($entry->dbObj, $entry->getDbPrefix(), $users);
	$user_check = array_keys($users);

//--- Process Mailbox
if ($debug) echo '<pre>';
if (!$error = $pop3->Open()) {
	if ($debug) echo 'Connected to the POP3 server &quot;' . $pop3->hostname."&quot;.\n";
	if (!$error = $pop3->Login($user, $password)) {
		if ($debug) echo "User &quot;$user&quot; logged in.\n";
		if (!$error = $pop3->Statistics($messages, $size)) {
			if ($debug) echo "There are $messages messages in the mail box with a total of $size bytes...\n\n";
				$result = $pop3->ListMessages('', TRUE);
				if (is_array($result)) {
					foreach ($result as $key => $val) {
						if ($debug) echo "\n*** Message " . $key . ', ID: "' . $val . "\"\n";
						if (!$error = $pop3->RetrieveMessage($key, $headers, $body, -1)) {

							//--- Multi-Part Boundary Check
							$boundary = NULL;
							$boundary_flag = FALSE;
							$boundary_check = array_filter($headers, 'boundary_check');
							if (count($boundary_check) > 0) {
								foreach ($boundary_check as $val) {
									if (preg_match('/boundary="(.*)"/', $val, $matches)) {
										$boundary = $matches[1];
									}
								}
							}


							//--- Parse Headers
							for ($line = 0; $line < count($headers); $line++) {
								if (preg_match('/From:.*<(.*@.*)>/', $headers[$line], $matches)) {
									$from = $matches[1];
									if ($debug) echo 'FROM:' . htmlspecialchars($from);
									if (array_search(strtolower($matches[1]), $user_check) === FALSE) {
										if ($debug) echo "~ REJECTED\n";
										$error = $pop3->DeleteMessage($key);
										continue 2;
									}
									$uid = $users[$from]['id'];
									$post_by = $users[$from]['post_by'];
								}

								//--- PolarBlog Post
								if (preg_match('/^Subject:(.*)/', $headers[$line], $matches)) {
									$pb_topic = (defined('POP3_TOPIC')) ? POP3_TOPIC : 0;
									$pb_title = trim($matches[1]);
									$pb_text = '';
									$pb_body = '';
									$pb_more = '';

									//--- Topics Request
									if ((defined('POP3_MAIL') && POP3_MAIL) && preg_match('/^GET TOPICS$/i', $pb_title)) {
										$topics = get_topics($entry->dbObj, $entry->getDbPrefix());
										if ($debug) {
											echo "\nTopics Request\n";
											print_r($topics);
										}
										send_topics($from, $post_by, $topics);
										$error = $pop3->DeleteMessage($key);
										continue 2;
									}

									//--- Parse Body
									for ($bline = 0; $bline < count($body); $bline++) {
										$body[$bline] = str_replace('<br>', '<br />', $body[$bline]);
										$body[$bline] = preg_replace('/^$/', '<br /><br />', $body[$bline]); //pseudo-paragraph break
										$body[$bline] = str_replace('  ', '&nbsp;&nbsp;', $body[$bline]);
										$body[$bline] = preg_replace('/=$/', '', $body[$bline]);
										$body[$bline] = ltrim($body[$bline]);

										//--- Topic
										if (preg_match('/TOPIC:(.*)/', $body[$bline], $matches)) {
											$pb_topic = trim($matches[1]);
											continue;
										}

										if (strpos($body[$bline], $boundary) !== FALSE) {
											$boundary_flag = TRUE;
											$body[$bline] = '';
										}

										//--- End Content-*  or MORE Flag
										if (($boundary_flag && strpos($body[$bline], 'Content-Disposition') !== FALSE) ||
										     preg_match('/::MORE::(.*)/', $body[$bline], $matches)
										   ) {
											$boundary_flag = FALSE;
											$pb_body = $pb_text;
											$pb_text = '';
											continue;
										}
										$pb_text .= $body[$bline] . ' ';

									}
									if (strlen($pb_body) > 0) {
										$pb_more = $pb_text;
									} elseif (strlen($pb_body) === 0 && count($body) > 0) {
										//Handle missing End Content-* for entries without a MORE flag
										$pb_body = implode(' ', $body);
									}
									$pb_body = str_replace('<br /> ', '<br />', $pb_body);
									$pb_more = str_replace('<br /> ', '<br />', $pb_more);

									if ($debug) {
										echo  "~ ACCEPTED\n";
										echo 'TID: ' . $pb_topic . "\n";
										echo 'Title:' . htmlspecialchars($pb_title) . "~\n";
										echo 'Body:' . htmlspecialchars($pb_body),"~\n";
										if (strlen($pb_more)) echo 'More:' . htmlspecialchars($pb_more),"~\n";
									}

									//--- Setup Entry
									$entry->setTitle($pb_title);
									$entry->setTopicId($pb_topic);
									$entry->setLineBreak(1);
									$entry->setDisplay(1);
									$entry->setAllowComments(1);
									$entry->setBody(ltrim($pb_body));
									$entry->setMore(ltrim($pb_more));
									$entry->setAdjustTime(1, 1, '+', 0, 0);
									$entry->setUid($uid);
									$entry->setPostBy($post_by);

									//--- Create Entry & Clean Up
									if (!$debug && $entry->insertEntry(TRUE)) {
										$pop3->DeleteMessage($key);
									} else {
										echo "Running DEBUG so not inserted or marked message $key for deletion as it normally would.\n";
										if ($debug_entry_object) {
											print' <pre>';
											print_r($entry);
											print '</pre>';
										}
									}
								}
							}

						}
					}
					if(empty($error) && (!$error = $pop3->Close())) {
						if ($debug) echo "\n\nDisconnected from the POP3 server &quot;" . $pop3->hostname . "&quot;.\n";
					}

				} else {
					$error = $result;
				}
		}
	}
}

	if ($error) {
		if ($debug) echo "<H2>Error: ",HtmlSpecialChars($error),"</H2>";
	}

if ($debug) echo "</pre>";




/**** FUNCTION ****/

/**
 * Builds array of PolarBlog users with post and POP3 posting access.
 *
 * @param object $db A database object reference.
 * @param string $db_prefix The PolarBlog database table prefix.
 * @param array $users Array reference to hold user data.
 *
 */
function get_pop3_users(&$db, $db_prefix, &$users) {
	$query = "SELECT
					id,
					email,
					post_by,
					pop3_alt_email
				 FROM
			 		{$db_prefix}users
			 	 WHERE
			 	 	pop3='1'
			 	   AND
			 	   	post_entry='1'";

	//--- Issue Query
	if ($db->query($query)) {
		//--- Check for results
		if ($db->getResultCnt() > 0) {
			//--- Retrieve Results
			while ($db->getRow()) {
				$std_email = strtolower(trim($db->row['email']));
				$users[$std_email]['id'] = strtolower($db->row['id']);
				$users[$std_email]['post_by'] = $db->row['post_by'];
				$alt_email = explode(',', $db->row['pop3_alt_email']);
				foreach ($alt_email as $email) {
					$email = strtolower(trim($email));
					$users[$email]['id'] = strtolower($db->row['id']);
					$users[$email]['post_by'] = $db->row['post_by'];
				}
			}
		}
	} else {
		//--- Query Error
		echo $db->getError();
	}
}


/**
 * Check a POP3 header line for a boundary marker.
 *
 * @param string $line The header line.
 *
 */
function boundary_check($line) {
	return strpos($line, 'boundary=');
}

/**
 * Builds an array of topic ID's and names
 *
 * @param object $db A database object reference.
 * @param string $db_prefix The PolarBlog database table prefix.
 * @return array $topics
 */
function get_topics(&$db, $db_prefix) {
	$topics = array();
	$query = "SELECT
					tid,
					name
				 FROM
			 		{$db_prefix}topics
			 	 ORDER BY
			 	 	tid";

	//--- Issue Query
	if ($db->query($query)) {
		if ($db->result_cnt > 0) {
			while ($db->getRow()) {
				$tid = (int) $db->row['tid'];
				$topics[$tid] = $db->row['name'];
			}
		}
	} else {
		//--- Query Error
		echo $db->getError();
		$stat = FALSE;
	}

	return $topics;
}


/**
 * Send user a list oftopic ID's and names
 *
 * @param string $email The user's email address.
 * @param array $topics An array of topics.
 * @return null
 */
function send_topics($email, $name, &$topics) {
	$langObj = new Localization(I18N_LANG, './lang/');
	$mail_msg = ' Id    ' . $langObj->get('TOPICS') . "\r\n";
	$mail_msg .= str_repeat('-', strlen($mail_msg) - 1) . "\r\n";
	$mail_debug_msg = '';
	$blog_name = (defined('BLOG_NAME')) ? BLOG_NAME : 'PolarBlog';
	$mail_subject = stripslashes(strip_tags($blog_name)) . ' ' . $langObj->get('TOPICS');

	foreach ($topics as $id => $topic) {
			$mail_msg .= ' ' . sprintf('% 2s', $id) . "   $topic\r\n";
	}

	if (defined('POP3_MAIL') && POP3_MAIL) {
		$mail = new PHPMailer();
		if (defined('MAIL_HOST')) {
			$mail->Host = MAIL_HOST;
			$mail_debug_msg = $mail->ErrorInfo . "\n";
		}
		$mail->AddCustomHeader('X-Tracker: PolarBlog POP3 Post');
		$mail->CharSet = I18N_CHARSET;
		$mail_debug_msg .= 'Charset - ' . $mail->ErrorInfo . '<br />';
		$mail->Mailer = MAIL_TYPE;
		$mail_debug_msg .= $mail->ErrorInfo . "\n";
		$mail->From = MAIL_FROM;
		$mail_debug_msg .= $mail->ErrorInfo . "\n";
		$mail->FromName = MAIL_FROM_NAME;
		$mail_debug_msg .= $mail->ErrorInfo . "\n";
		$mail->Subject = $mail_subject;
		$mail_debug_msg .= $mail->ErrorInfo . "\n";

		$send_mail = FALSE;
		if (strlen($email) > 0) {
			$mail->AddAddress($email, $name);
			$mail->AddReplyTo(MAIL_FROM, MAIL_FROM_NAME);
			$mail_debug_msg .= $mail->ErrorInfo . "\n";
			$send_mail = TRUE;
		}
		$mail->Body = $mail_msg;
		$mail_debug_msg .= $mail->ErrorInfo . "\n";

		if ($send_mail) {
			$stat = $mail->Send();
		}

		if (defined('MAIL_DEBUG') && MAIL_DEBUG) {
			echo "Mail Debug:\n" . $mail_debug_msg;
		}
	}
}
?>
