<?php
/*
 This program is distributed under the terms of the GNU General Public License.
 See the README & COPYING files for more information.
 Copyright (C) 2004-2006  Kevin L. Papendick <kevinp@polarlava.com>
*/


	//--- Config
	require('./config/config.php');
	setlocale(LC_TIME, I18N_LANG);
	require_once(LIB_PATH . 'PbTrackback.php');

	//--- Untaint Variables
	$clean = array();
	$clean['title'] = (isset($_POST['title']) && preg_match('/[\r\n\w:\/.-~]+/', $_POST['title'])) ? $_POST['title'] : NULL;
	$clean['excerpt'] = (isset($_POST['excerpt']) && preg_match('/[\r\n\w:\/.-~]+/', $_POST['excerpt'])) ? $_POST['excerpt'] : NULL;
	$clean['url'] = (isset($_POST['url']) && preg_match('/^[\w:\/.-~]+$/', $_POST['url'])) ? $_POST['url'] : FALSE;
	$clean['blog_name'] = (isset($_POST['blog_name']) && preg_match('/[\r\n\w:\/.-~]+/', $_POST['blog_name'])) ? $_POST['blog_name'] : NULL;
	$clean['eid'] = (isset($_GET['eid']) && preg_match('/^\d{1,5}$/', $_GET['eid'])) ? (int) $_GET['eid'] : -1;
	if (isset($_SERVER['CONTENT_TYPE'])) {
		preg_match('/charset=(.+)/', $_SERVER['CONTENT_TYPE'], $match);
	}
	$clean['charset'] = (isset($match[1])) ? $match[1] : I18N_CHARSET;

	if (isset($_SERVER['REQUEST_METHOD'])  && $_SERVER['REQUEST_METHOD'] === 'GET' && $clean['eid'] > 0) {
		header('Location: ' . BASE_URL . '?eid=' . $clean['eid']);
		exit;
	} elseif (isset($_SERVER['REQUEST_METHOD']) && $_SERVER['REQUEST_METHOD'] === 'GET') {
		header('Location: ' . BASE_URL);
		exit;
	}


	$tb = new PbTrackback(DB_PREFIX, $rbl_services);
	$tb->setTrackbackOptions(TB_STRIP_TAGS, TB_EXCERPT_LENGTH);
	$tb->setTrackback($clean['eid'], $clean['charset'], $clean['url'], $clean['title'], $clean['excerpt'], $clean['blog_name']);
	$tb->receiveTrackback();
	echo $tb->getResponse();
?>